#ifndef _KERNEL_VERSION_H
#define _KERNEL_VERSION_H
/*  
 *  Kernel version dependencies for zftape
 *
 */
#include <linux/config.h>
#include <linux/version.h>

/* this makes the Kernel version numbers readable, shamelessly copied from
 * ftape-2.04
 */
#define KERNEL_VER(major,minor,sublvl) (((major)<<16)+((minor)<<8)+(sublvl))

/*
 *  known compatability problems between different kernel
 *  versions.
 *  (c)  Claus-Justus Heine, January 1996
 */

#if (LINUX_VERSION_CODE < KERNEL_VER(1,3,28))
typedef unsigned short kdev_t;
#endif
#ifdef MODULE
#	if (LINUX_VERSION_CODE > KERNEL_VER(1,3,37))
#		ifdef MODVERSIONS
#			include <linux/modversions.h>
#		endif
#	else
#		ifdef MODVERSIONS
#			undef MODVERSIONS
#			ifndef CONFIG_MODVERSIONS
#				define CONFIG_MODVERSIONS
#			endif
#			include <linux/module.h>
#		else
#			ifdef CONFIG_MODVERSIONS
#				undef CONFIG_MODVERSIONS
#			endif
#		endif
#	endif
#endif
#if (LINUX_VERSION_CODE < KERNEL_VER(1,3,22)) /* don't know exactly, but doesn't matter */
#define _IOC_SIZE(cmd) (((cmd) & IOCSIZE_MASK) >> IOCSIZE_SHIFT)
#define _IOC_DIR(cmd)  (cmd)
#define _IOC_WRITE IOC_IN
#define _IOC_READ  IOC_OUT
#endif


#endif /* _KERNEL_VERSION_H */

